﻿/*
Elastic Comp Changer is a script that will change the duration of your composition, its layers and its nested layers at the same time.
Elastic Comp Changer can also be used as an animation tool, it will move everything placed after the time navigator of your timeline:
the in points, the out points or the start time of your layers and its keyframes. This way you can easily fine-tune certain parts of your animation.
Elastic Comp Changer only change unlocked layers.

Elastic Comp Changer can be put either in the Scripts folder or the scriptUIPanels folder of your application, it can work as a floating panel or as a dockable panel.

Elastic Comp Changer has 1 panel and two tabbed panels:

Add or remove frames
Elastic works with frames, not seconds. In the text box, enter the number of frames you want to add or remove to your comp.
+ button: Add frames to the current duration of the composition.
- button: Remove frames from the current duration of the composition.

Options
Offset keyframes: if checked, this option will move every keyframe that is after the time navigator.
Include precomps: if checked, this option will add or remove frames to the precomps used in the current comp, it will change the duration of the precomps and the outpoints of its layers.
It will also add or remove frames to the precomps used in these precomps until there is no more precomp to process.
I you want some precomps to remain unchanged then you can lock them, as the script only changes unlocked layers.
Include locked layers:  if checked, this option will modify unlocked layers and locked layers.

Mode
-Start Time: if this mode is actived, then Elastic Comp Changer will move the start time of the layers placed after the time navigator of the timeline.
-In Point: if this mode is actived, then Elastic Comp Changer will move the in-Point of the layers placed after the time navigator of the timeline.
-Selected only: if this mode is checked, then Elastic Comp Changer will only modify the selected layers of your current comp,


Mathieu Glatigny

October 2016


    */
{
function ElasticCompChanger(thisObj) {
          function myScript_buildUI(thisObj) {
                    var myPanel = (thisObj instanceof Panel) ? thisObj : new Window("palette", "ELASTIC MAN", undefined);
 
                    res="group{orientation:'column', alignment:['left', 'top'], alignChildren:['fill', 'fill'],\
                            myPanel1: Panel{text:'Add or remove frames:', orientation:'column', alignChildren:['center', 'center'],\
                            firstButtonsG: Group{orientation:'row', alignment:['', ''], alignChildren:['fill', 'fill'],\
                                                myPanelItem1: Button{text:'-'},\
                                                myPanelItem2: EditText{text:''},\
                                                myPanelItem3: Button{text:'+'},\
                                                },\
                                                },\
                                                myPanel2: Panel{type:'tabbedpanel', orientation:'column', alignChildren:['center', 'center'],\
                                                myTab1: Panel{type:'tab', text:'Options', orientation:'column', alignChildren:['', 'center'],spacing:10,\
                                                myPanelItem1: Checkbox{text:'Offset keyframes'},\
                                                myPanelItem2: Checkbox{text:'Include precomps'},\
                                                myPanelItem3: Checkbox{text:'Include locked layers'},\
                                                },\
                                                myTab2: Panel{type:'tab', text:'Mode', orientation:'column', alignChildren:['', 'center'],spacing:10,\
                                                myPanelItem1: RadioButton{text:'Start Time'},\
                                                myPanelItem2: RadioButton{text:'In Point'},\
                                                myPanelItem3: RadioButton{text:'Selected only'},\
                                                },\
                                                },\
                                        },\
                                }"

                    //Add resource string to panel
                    myPanel.grp = myPanel.add(res);
                    
                    //////////////ADDITIONNAL_LAYOUT
                    var fCount,kOption,pOption,stOption,ipOption,uOption;
                    
                    myPanel.grp.maximumSize  =  "width: 165, height: 250";

                    myPanel.grp.myPanel1.firstButtonsG.myPanelItem1.size = "width: 30, height: 20";
                    fCount=myPanel.grp.myPanel1.firstButtonsG.myPanelItem2;
                    fCount.characters = 6;
                    fCount.text = 0;
                    myPanel.grp.myPanel1.firstButtonsG.myPanelItem3.size = "width: 30, height: 20";

                    kOption = myPanel.grp.myPanel2.myTab1.myPanelItem1;
                    kOption.alignment ="left";
                    pOption = myPanel.grp.myPanel2.myTab1.myPanelItem2;
                    pOption.alignment ="left";
                    uOption = myPanel.grp.myPanel2.myTab1.myPanelItem3;
                    uOption.alignment ="left";
                    stOption=myPanel.grp.myPanel2.myTab2.myPanelItem1;
                    stOption.alignment ="left";
                    ipOption=myPanel.grp.myPanel2.myTab2.myPanelItem2;
                    ipOption.alignment ="left";
                    soOption=myPanel.grp.myPanel2.myTab2.myPanelItem3;
                    soOption.alignment ="left";
                    stOption.value=true;
                    
                    
                    


                    
 ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
myPanel.grp.myPanel1.firstButtonsG.myPanelItem1.onClick = function(){elasticMan(-1)};
myPanel.grp.myPanel1.firstButtonsG.myPanelItem3.onClick = function(){elasticMan(1)};
 ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 
function elasticMan(frames){

//////////////////////////////////////////////////////////////////FUNCTIONS

//inPoints Mode
function offsetInPoints(compInput,frames){
    
    var  curCompTime =  compInput.time;      
    var layersToOffset = [];
    var actvlyrsToOffset = [];
       
    //store layers to offset in a array
	for(t=1; t<=compInput.numLayers; t++){
        
		var curLayer=compInput.layer(t);
        
        if(curLayer.locked == false){
                      
            if(curLayer.inPoint > curCompTime){
                layersToOffset.push(curLayer);
                };
            //else offset outpoint only
            if(curLayer.outPoint>curCompTime && curLayer.inPoint<= curCompTime){
                actvlyrsToOffset.push(curLayer);
                };
            
            };
        
		};
    
    if(frames == 1){compInput.duration+= theOffset;};
    
    //offset inpoints of layers to offset array
    for(a=0; a<actvlyrsToOffset.length; a++){
        
        var curActiv = actvlyrsToOffset[a];
        var savOut = curActiv.outPoint;
        curActiv.outPoint = savOut + theOffset;
        curActiv.selected = false;
        
        };
    
    for(u=0; u<layersToOffset.length; u++){
        
        var saveIn = layersToOffset[u].inPoint;
        var saveOut = layersToOffset[u].outPoint;
        layersToOffset[u].inPoint = saveIn + theOffset;
        layersToOffset[u].outPoint = saveOut + theOffset;
        layersToOffset[u].selected = false;
        
        };

	};
//

//startTime Mode
function offsetStartTime(compInput,frames){
           
    var layersToOffset = [];
    var actvlyrsToOffset = [];
    
	//store layers to offset in separate arrays
    for(t=1; t<=compInput.numLayers; t++){
        
		var curLayer=compInput.layer(t);
                       
        if(curLayer.locked == false){
            
            if(curLayer.inPoint>curTime){
                layersToOffset.push(curLayer);
                };
            //else offset outpoint only
            if(curLayer.outPoint>curTime && curLayer.inPoint<= curTime){
                actvlyrsToOffset.push(curLayer);
                };
            
            };
        
		};

    if(frames == 1){compInput.duration+= theOffset;};
    
    for(a=0; a<actvlyrsToOffset.length; a++){

        var curActiv = actvlyrsToOffset[a];
        curActiv.outPoint += theOffset;
        curActiv.selected = false;
        
        };
    
    for(u=0; u<layersToOffset.length; u++){
        
        layersToOffset[u].startTime += theOffset;
        layersToOffset[u].selected = false;
        
        };
    
	};
//

//removes duplicates in array
function RemoveDupArray(a){
    
    removeDup:for(j=0;j<a.length;j++){
        for(x=0;x<subComps.length;x++){
            if(subComps[x] == a[j]) continue removeDup;
            };
        subComps[subComps.length] =a[j];
        };
    return subComps;
    
    };
//

function getSubComps(theComp){

  for (var i = 1; i <= theComp.numLayers; i++){
      
      var curLayer = theComp.layer(i);
      
      //check if the inPoints of the layers are after the cursor
      
      if(!(curLayer.inPoint<curTime && curLayer.outPoint<curTime)){
      
              var curSource = curLayer.source;

            if (curSource instanceof CompItem){

              compLayers.push(curSource);

              getSubComps(curSource);

            };
        };//end check if layer is after the cursor

  };//end of loop

};
//

function getSubCompsFromLayer(theLayer){

  for (var i = 1; i <= theLayer.numLayers; i++){
      
      var curLayer = theLayer.layer(i);
      var curSource = curLayer.source;
      
      if (curSource instanceof CompItem){
          
          compLayers.push(curSource);
          getSubCompsFromLayer(curSource);
                                                      
            };

  };//end of loop

 };
//

function grabKeys(propInput, timeRef,direction){
	
	if(propInput instanceof Property){
        
		var totalKeys, prop, keyIndexList, curKeyIndex, curKeyValue, curKeyTime, inin, outin , ab, cb, ie, oe, sab, scb, ist , ost, rov, twoDS, threeDS;
		twoDS = PropertyValueType.TwoD_SPATIAL;
		threeDS = PropertyValueType.ThreeD_SPATIAL;
		
		keyIndexList = new Array();
		totalKeys = propInput.numKeys;
		if(totalKeys > 0){
			for(i = 1; i<= totalKeys; i++){
				if(
                (direction == 1 && propInput.keyTime(i)>timeRef) || (direction == -1 &&propInput.keyTime(i)<timeRef)
                ){//add a condition for forward or backward timeref
				curKeyTime = propInput.keyTime(i); 
				curKeyIndex = i;
				curKeyValue = propInput.keyValue(i);
				inin = propInput.keyInInterpolationType(curKeyIndex);
				outin = propInput.keyOutInterpolationType(curKeyIndex);
				
				if(inin == KeyframeInterpolationType.BEZIER && outin == KeyframeInterpolationType.BEZIER){
					ab = propInput.keyTemporalAutoBezier(curKeyIndex);
					cb = propInput.keyTemporalContinuous(curKeyIndex);}
				
				if(inin != KeyframeInterpolationType.HOLD || outin != KeyframeInterpolationType.HOLD){
					ie = propInput.keyInTemporalEase(curKeyIndex);
					oe = propInput.keyOutTemporalEase(curKeyIndex);}
				
				if(propInput.propertyValueType== twoDS || propInput.propertyValueType== threeDS){
					sab = propInput.keySpatialAutoBezier(curKeyIndex);
					scb = propInput.keySpatialContinuous(curKeyIndex);
					ist = propInput.keyInSpatialTangent(curKeyIndex);
					ost = propInput.keyOutSpatialTangent(curKeyIndex);
					rov = propInput.keyRoving(curKeyIndex);}
				keyIndexList[keyIndexList.length] = {"curKeyTime":curKeyTime, "curKeyIndex":curKeyIndex, "curKeyValue":curKeyValue, "inin":inin, "outin":outin, "ab":ab, "cb":cb, "ie":ie, "oe":oe, "sab":sab, "scb":scb,"ist":ist,"ost":ost,"rov":rov};
				 }//end of condition
				}//end of loop
			return keyIndexList;
            
			}else{return null;}
		
		};//end of property inpout check
		
	};//end of grabKey function
//

function removeKeys(propInput, timeRef, direction){
    
	if(propInput instanceof Property){
		for (var i = propInput.numKeys; i >= 1; i--){
			if ((direction == 1 && propInput.keyTime(i)>timeRef) || (direction == -1 && propInput.keyTime(i)<timeRef))//condition 1 push the keyfrmaes in the opposite direction if start time mode is checked
			propInput.removeKey(i);}
		};
	};
//

function pasteKeys(propInput, keysAry,timeRef, direction){
    
	try{
        
	if(propInput instanceof Property && keysAry instanceof Array){
        
			var keysAryLength, newKeytime, addNewKey, newKeyIndex;
			keysAryLength= keysAry.length;
			for(k = 0; k<keysAryLength; k++){
                if(direction == 1){
                    addNewKey = propInput.addKey(keysAry[k].curKeyTime + theOffset); //set offset here
                    }else if(direction == -1){ //push the keyfrmaes in the opposite direction if start time mode is checked
                        addNewKey = propInput.addKey(keysAry[k].curKeyTime - theOffset); //set offset here
                        };
				
				newKeyIndex = addNewKey;
				propInput.setValueAtKey(newKeyIndex, keysAry[k].curKeyValue);
				if(keysAry[k].inin != KeyframeInterpolationType.HOLD || keysAry[k].outin != KeyframeInterpolationType.HOLD){
				propInput.setTemporalEaseAtKey(newKeyIndex,keysAry[k].ie,keysAry[k].oe,);}//paste velocity				
				propInput.setInterpolationTypeAtKey(newKeyIndex,keysAry[k].inin,keysAry[k].outin);
				if(keysAry[k].inin == KeyframeInterpolationType.BEZIER && keysAry[k].outin == KeyframeInterpolationType.BEZIER && keysAry[k].cb){
					propInput.setTemporalContinuousAtKey(newKeyIndex,keysAry[k].cb);
					propInput.setTemporalAutoBezierAtKey(newKeyIndex,keysAry[k].ab);
					}//check Bezier
				if(propInput.propertyValueType==PropertyValueType.TwoD_SPATIAL || propInput.propertyValueType==PropertyValueType.ThreeD_SPATIAL){
					propInput.setSpatialContinuousAtKey(newKeyIndex,keysAry[k].scb);
					propInput.setSpatialAutoBezierAtKey(newKeyIndex,keysAry[k].sab);
					propInput.setSpatialTangentsAtKey(newKeyIndex,keysAry[k].ist, keysAry[k].ost);
					propInput.setRovingAtKey(newKeyIndex, keysAry[k].rov);
					}//check2d or3d spatial
                
				}return true;//end of loop
		};//end of property inpout check
    
	}catch(err){if(propInput.propertyGroup(1) != null){
		alert("There is something strange at frame " + (keysAry[k].curKeyTime)*myComp.frameRate +  "\n" + propInput.propertyGroup(1).parentProperty.containingComp.name+ "\n" + propInput. propertyGroup(1).parentProperty.name + "\n" +propInput.name );
		}else{alert("There is something strange at frame " + (keysAry[k].curKeyTime)*myComp.frameRate)}
		};//end of catch
    
	}//end of pasteKAys function

//

//this function will call grabKeys, removeKeys and pasteKeys functions if a property have keyframes
function offKeys (propParent, timeRef, direction){
    if (propParent != null){
        var curProp;
        for(var i=1; i<=propParent.numProperties; i++){
            curProp = propParent.property(i);
            if((curProp.propertyType == PropertyType.PROPERTY) && (curProp.numKeys>0) && curProp.matchName != ("ADBE Time Remapping") && curProp.dimensionsSeparated == false){

				var a = grabKeys(curProp,timeRef, direction);
                 removeKeys(curProp,timeRef, direction);
                 pasteKeys(curProp,a,timeRef, direction);
         
                }else if((curProp.propertyType == PropertyType.PROPERTY) && (curProp.numKeys>0) && curProp.matchName == ("ADBE Time Remapping")){
                    var keysAry = grabKeys(curProp,timeRef, direction);
				pasteKeys(curProp,keysAry,timeRef, direction);
                var keysToRemove =[];
                
                for (rk=1; rk<=curProp.numKeys; rk++){
                    for(ck=0; ck<keysAry.length; ck++){
                        if(curProp.keyTime(rk) == keysAry[ck].curKeyTime && curProp.keyValue(rk) == keysAry[ck].curKeyValue){
                            keysToRemove[keysToRemove.length] = rk;
                            };//end of condition
                        };//end of loop 2
                    

                    };//end of loop1
                //remove these keys
                for ( jj = keysToRemove.length-1; jj >=0; jj--){curProp.removeKey(keysToRemove[jj])}
                    }
            else if((curProp.propertyType == PropertyType.INDEXED_GROUP) || (curProp.propertyType == PropertyType.NAMED_GROUP)){
                    offKeys(curProp,timeRef, direction);
                    };
            };
        };
    }; 

//this function grab locked layers
function grabLckd(compInput){
    
    var lockedLayers = [];
    //var preComps =[];
    
    //store locked layers to in a array
    for(t=1; t<=compInput.numLayers; t++){
        
        var curLayer=compInput.layer(t);
        
        if(curLayer.locked == true){lockedLayers[lockedLayers.length]=curLayer};
        
        };
    
    return lockedLayers;
    
    };
//
//this function unlock locked layers
function locker(aryInput,value){
    
    for(u=0; u<aryInput.length; u++){
        
        aryInput[u].locked = value;
        
        };
    
    };
//
//
 
 ///////////////////////////////////////////////////////////MAIN CODE
 
    var myComp = app.project.activeItem;
    
    if(myComp != null && myComp instanceof CompItem){
        
        var curTime = myComp.time;
        var frameOffset = Number(fCount.text);
        var theOffset = currentFormatToTime(frameOffset,myComp.frameRate)*frames; // this converts frames to seconds
        var compLayers = [myComp];
        var subComps = [];
        var lckdLyrs = [];
        
        
        app.beginUndoGroup("elastic comp change");
        
        //check wich mode is activated
        if(ipOption.value== true && soOption.value== false){
            
            ////////////////////////////////////////////////////////////////////////////////////the inPoints Mode is activated
            

            //check if the include precomps option is activated
            if(pOption.value == true){
                
                getSubComps(myComp);
                RemoveDupArray(compLayers);
                
                //process precomps
                if(subComps.length>0){
                    for(sc=subComps.length-1; sc>=0; sc--){
                        
                        var curComp = subComps[sc];
                        
                        ///check if the include locked layers is activated
                        if(uOption.value == true){
                            var pLckdLyrs = [];
                            pLckdLyrs=grabLckd(curComp);
                            locker(pLckdLyrs,false);
                            };//end check if the include locked layers is activated
                                                                        
                        //check if the offset keyframes option is activated
                        if(kOption.value == true){
                                                                                  
                            for(t=1; t<=curComp.numLayers; t++){
                                
                                var curLayer=curComp.layer(t);
                                if(/*curLayer.outPoint>curTime &&*/ curLayer.locked == false)
                                offKeys(curLayer,curTime,1);
                                
                                };//end of loop
                            
                            writeLn('Offsetting Keyframes in: ' + curComp.name);
                                                                                                            
                            };//end of check if the offset keyframes option is activated
                        
                        offsetInPoints(curComp,frames);
                        writeLn('Offsetting Layers In Points in: ' + curComp.name);
                        
                        if(uOption.value == true){locker(pLckdLyrs,true);}//relock layers if the include locked layers is activated
                        
                        };
                    //if the offset is negative, change duration after the inPoints
                    if(frames == -1){
                            for(sc=subComps.length-1; sc>=0; sc--){
                                subComps[sc].duration+= theOffset;
                            };
                        };//end if the offset is negative, change duration after the inPoints
                    };
                
                }else if(pOption.value == false){
                                                          
                    //dont process precomps
                    
                    //check if the include locked layers option is activated
                    if(uOption.value == true){
                        lckdLyrs=grabLckd(myComp);
                        locker(lckdLyrs,false);
                        };
                    
                    //check if the offset keyframes option is activated
                    if(kOption.value == true){
                        
                        
                        for(t=1; t<=myComp.numLayers; t++){
                            
                            var curLayer=myComp.layer(t);
                            if(/*curLayer.outPoint>curTime && */curLayer.locked == false)
                            offKeys(curLayer,curTime,1);
                            
                            };//end of loop
                        
                        writeLn('Offsetting Keyframes in: ' + myComp.name);
                                                                                              
                        };//end ofcheck if the offset keyframes option is activated
                    
                    offsetInPoints(myComp,frames);
                    
                    if(uOption.value == true){locker(lckdLyrs,true);};//relock layers if the include locked layers option is activated
                    
                    writeLn('Offsetting Layers In Points in: ' + myComp.name);
                    
                    };//end dont process precomps
                
                if(frames == -1){myComp.duration+= theOffset;};
                
                //if(uOption.value == true){alert(lckdLyrs.length);locker(lckdLyrs,true);};//relock layers if the include locked layers option is activated
            
            }else if(stOption.value== true && soOption.value== false){
                /////////////////////////////////////////////////////////////////////////////////////the Start Time Mode is activated
                
                //check if the include locked layers is activated
                if(uOption.value == true){
                    lckdLyrs=grabLckd(myComp);
                    locker(lckdLyrs,false);
                    };
                
                //check if the offset is negative
                if(frames == -1){
                    offsetStartTime(myComp,frames);
                    writeLn('Offsetting Layers Start Time in ' + myComp.name);
                    }
                

                
                //check if the offset keyframes option is activated
                if(kOption.value == true){
                    
                    for(t=1; t<=myComp.numLayers; t++){
                        
                        var curLayer=myComp.layer(t);
                        
                        if(curLayer.outPoint>=curTime && curLayer.inPoint<= curTime && curLayer.locked == false)
                        offKeys(curLayer,curTime,1);
                        
                        if(curLayer.inPoint>curTime && curLayer.locked == false)
                        offKeys(curLayer,curTime,-1);//then push keyframes in the opposite direction
                        
                        if(curLayer.outPoint<curTime && curLayer.locked == false)//offset keys regardless the layer is active
                        offKeys(curLayer,curTime,1);
                        
                        };//end of loop
                    
                    };//end of check if the offset keyframes option is activated
                    
                //check if the include precomps option is activated
                if(pOption.value == true){
                    
                    for(t=1; t<=myComp.numLayers; t++){                        
                        var curLayer=myComp.layer(t);
                        if(curLayer.outPoint>curTime && curLayer.inPoint<= curTime && curLayer.locked == false && curLayer.source instanceof CompItem){
                            compLayers.push(curLayer.source)
                            getSubCompsFromLayer(curLayer.source);                          
                            };//end of condition                       
                        };//end of loop
                    
                    compLayers.shift();//remove myComp from the recomps to process
                    RemoveDupArray(compLayers);
                    
                    //process precomps
                    if(subComps.length>0){
                        
                        for(sc=subComps.length-1; sc>=0; sc--){
                            
                            var curComp = subComps[sc];
                            
                           ///check if the include locked layers is activated
                            if(uOption.value == true){
                                var pLckdLyrs = [];
                                pLckdLyrs=grabLckd(curComp);
                                locker(pLckdLyrs,false);
                                };//end check if the include locked layers is activated
                            
                            offsetInPoints(curComp,frames);
                            
                            //offset keyframes in precomps
                            if(kOption.value == true){
                                
                                for(t=1; t<=curComp.numLayers; t++){
                                    var curLayer=curComp.layer(t);
                                    if(curLayer.outPoint>=curComp.time && curLayer.locked == false)
                                    offKeys(curLayer,curComp.time,1);//use precomp time rather than comp time
                                    curLayer.selected = false;
                                    };
                                
                                writeLn('Offsetting Keyframes in: ' + curComp.name);
                                
                                };//end offset keyframes in precomps
                            
                            writeLn('Offsetting Layers In Points in: ' + curComp.name);
                            
                            if(uOption.value == true){locker(pLckdLyrs,true);}//relock layers if the include locked layers is activated
                            
                            };//end of loop 1
                                                                                                                      
                        if(frames == -1){
                            for(sc=subComps.length-1; sc>=0; sc--){
                                subComps[sc].duration+= theOffset;
                                };//end of loop 2
                            };
                        
                        };//end of process recomps
                    
                    }; //end of check if the include precomps option is activated 
                
                   /* //offset keyframes in precomps
                    if(subComps.length>0){
                        for(sc=subComps.length-1; sc>=0; sc--){
                            var curComp = subComps[sc];
                            for(t=1; t<=curComp.numLayers; t++){
                                var curLayer=curComp.layer(t);
                                if(curLayer.outPoint>=curComp.time && curLayer.locked == false)
                                offKeys(curLayer,curComp.time,1);//use precomp time rather than comp time
                                curLayer.selected = false;
                                };
                            writeLn('Offsetting Keyframes in: ' + subComps[sc].name);
                            };//end of loop through precomps
                        };//end offset keyframes in precomps*/
                    
                    writeLn('Offsetting Keyframes in: ' + myComp.name);
                    
                    //};//end of check if the offset keyframes option is activated
                
                //check if the offset is positive
                if(frames == 1){
                    offsetStartTime(myComp,frames);
                    writeLn('Offsetting Layers Start Time in ' + myComp.name);
                    };
                
                if(frames == -1){myComp.duration+= theOffset;};
                
                //check if the include locked layers is activated-relock layers
                if(uOption.value == true){locker(lckdLyrs,true);};
                //if(uOption.value == true && pOption.value == true){locker(lckdLyrs,true);};
                
                };//end check wich mode is activated
            
            ///////////////////////////////////////////////////////////////////////////check if the selected only option is activated
            if(soOption.value == true){
                
                //check if layers are selected
                
                if(myComp.selectedLayers.length != 0){
                
                    var normalLayers = [];
                    
                    for(t=1; t<=myComp.numLayers; t++){
                        
                        var curLayer=myComp.layer(t);
                        //check if the layer is selected
                        if(curLayer.selected == true){
                            
                            normalLayers.push(curLayer);
                            
                            if(curLayer.source instanceof CompItem && pOption.value == true){
                                compLayers.push(curLayer.source);
                                getSubCompsFromLayer(curLayer.source);
                                }
                            //check if the offset keyframes option is activated
                            if(kOption.value == true){
                                if(curLayer.outPoint>curTime && curLayer.inPoint<= curTime && curLayer.locked == false)
                                offKeys(curLayer,curTime,1);
                                };//check if the offset keyframes option is activated
                                
                            };// end check if the layer is selected
                        };
                    
                     //check if myComp needs to be modified
                     for(v=0; v<normalLayers.length; v++){
                         var curItem = normalLayers[v];
                         if( Math.round(curItem.outPoint) == Math.round(myComp.duration)){
                             var maxDuration = myComp.duration;
                             };
                         };
                     
                     if(maxDuration != null){myComp.duration+= theOffset;}
                     
                     //process layers if frames is negative
                     if(frames == -1){
                         for(v=0; v<normalLayers.length; v++){
                             var curItem = normalLayers[v];
                             curItem.outPoint+= theOffset;
                             };
                         };
                     
                    
                    //process precomps
                    compLayers.shift();//remove myComp from the recomps to process
                    RemoveDupArray(compLayers);
                    
                    if(subComps.length>0){
                        for(sc=subComps.length-1; sc>=0; sc--){
                            
                            var curComp = subComps[sc];
                            
                            ///check if the include locked layers is activated
                            if(uOption.value == true){
                                var pLckdLyrs = [];
                                pLckdLyrs=grabLckd(curComp);
                                locker(pLckdLyrs,false);
                                };//end check if the include locked layers is activated
                            
                            offsetInPoints(curComp,frames);
                            
                            //offset keyframes in precomps
                            if(kOption.value == true){
                                
                                for(t=1; t<=curComp.numLayers; t++){
                                    var curLayer=curComp.layer(t);
                                    if(/*curLayer.outPoint>curComp.time && curLayer.inPoint<=curComp.time&& */curLayer.locked == false)
                                    offKeys(curLayer,curComp.time,1);//use precomp time rather than comp time
                                    curLayer.selected = false;
                                    };
                                
                                writeLn('Offsetting Keyframes in: ' + curComp.name);
                                
                                };//end offset keyframes in precomps
                            
                            if(uOption.value == true){locker(pLckdLyrs,true);}//relock layers if the include locked layers is activated
                            
                            };
                        
                        if(frames == -1){
                            for(sc=subComps.length-1; sc>=0; sc--){
                                subComps[sc].duration+= theOffset;
                                };
                            };//end if the offset is negative, offset duration after the inPoints 
                        };
                    //process layers if the offset is positve
                    if(frames == 1){
                        for(v=0; v<normalLayers.length; v++){
                            var curItem = normalLayers[v];
                            curItem.outPoint+= theOffset;
                            };
                    };//end process layers if the offset is positve
            
            }else{alert("Select layer(s)")};

                
                };//check if the selected only option is activated
            

        clearOutput();
        
        app.endUndoGroup;
        
    
    }else{alert('Select a comp')};

       
    };//end of elasticMan function
//
 
                    //Setup panel sizing and make panel resizable
                    myPanel.layout.layout(true);
                    myPanel.grp.minimumSize = myPanel.grp.size;
                    myPanel.layout.resize();
                    myPanel.onResizing = myPanel.onResize = function () {this.layout.resize();}
 
                    return myPanel;
          }
      

 
          var myScriptPal = myScript_buildUI(thisObj);
 
 
          if ((myScriptPal != null) && (myScriptPal instanceof Window)) {
                    myScriptPal.center();
                    myScriptPal.show();
                    }
          }
 
 
          ElasticCompChanger(this);
}